/*  XRoar - a Dragon/Tandy Coco emulator
 *  Copyright (C) 2003-2004  Ciaran Anscomb
 *
 *  See COPYING for redistribution conditions. */

#ifndef __M6809_H__
#define __M6809_H__

#include "machine.h"
#include "types.h"

#define reg_a reg_accum.byte_values.upper
#define reg_b reg_accum.byte_values.lower
#define reg_d reg_accum.word_value

typedef union {
	Uint16 word_value;
	struct {
#ifdef WRONG_ENDIAN
		Uint8 lower;
		Uint8 upper;
#else
		Uint8 upper;
		Uint8 lower;
#endif
	} byte_values;
} accumulator_t;

extern Uint32 current_cycle;
extern Uint32 next_disk_interrupt, enable_disk_interrupt;

extern Uint8 reg_cc, reg_dp;
extern Uint16 reg_x, reg_y, reg_u, reg_s, reg_pc;
extern accumulator_t reg_accum;

extern Uint32 nmi, firq, irq;
extern Uint32 wait_for_interrupt;
extern Uint32 skip_register_push;

void m6809_init(void);
void m6809_reset(void);
void m6809_cycle(void);
//void m6809_nmi(void);
//void m6809_firq(void);
//void m6809_irq(void);

#endif  /* __M6809_H__ */
